/*###############################################################################
# Linux Management Providers (LMP), Base_Server provider package
# Copyright (C) 2007 Ilsoo Byun, ETRI <widepis@etri.re.kr ,widepis@empal.com>
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2008 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
###############################################################################*/

#ifndef CMPIOPENDRIM_COMPUTERSYSTEM_H_
#define CMPIOPENDRIM_COMPUTERSYSTEM_H_

#include "OpenDRIM_ComputerSystem.h"

CMPIObjectPath* Base_Server_OpenDRIM_ComputerSystem_toCMPIObjectPath(const CMPIBroker* broker, const OpenDRIM_ComputerSystem& instance);

CMPIInstance* Base_Server_OpenDRIM_ComputerSystem_toCMPIInstance(const CMPIBroker* broker, const OpenDRIM_ComputerSystem& instance);

void Base_Server_OpenDRIM_ComputerSystem_toCPP(const CMPIBroker* broker, const CMPIObjectPath* ref, OpenDRIM_ComputerSystem& instance);

void Base_Server_OpenDRIM_ComputerSystem_toCPP(const CMPIBroker* broker, const CMPIInstance* ci, OpenDRIM_ComputerSystem& instance);

void Base_Server_OpenDRIM_ComputerSystem_toCPP(const CMPIBroker* broker, const CMPIArgs* in, OpenDRIM_ComputerSystem_RequestStateChange_In& args);

void Base_Server_OpenDRIM_ComputerSystem_toCMPIArg(const CMPIBroker* broker, CMPIArgs* out, const OpenDRIM_ComputerSystem_RequestStateChange_Out& args);

void Base_Server_OpenDRIM_ComputerSystem_toCPP(const CMPIBroker* broker, const CMPIArgs* in, OpenDRIM_ComputerSystem_SetPowerState_In& args);


#endif /*CMPIOPENDRIM_COMPUTERSYSTEM_H_*/
