/*###############################################################################
# Linux Management Providers (LMP), Base_Server provider package
# Copyright (C) 2007 Ilsoo Byun, ETRI <widepis@etri.re.kr ,widepis@empal.com>
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2008 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
###############################################################################*/

#ifndef OPENDRIM_COMPUTERSYSTEMCAPABILITIESACCESS_H_
#define OPENDRIM_COMPUTERSYSTEMCAPABILITIESACCESS_H_

#include "Base_Server_Common.h"

#include "OpenDRIM_ComputerSystemCapabilities.h"

int Base_Server_OpenDRIM_ComputerSystemCapabilities_load(const CMPIBroker* broker, string& errorMessage);

int Base_Server_OpenDRIM_ComputerSystemCapabilities_unload(string& errorMessage);

int Base_Server_OpenDRIM_ComputerSystemCapabilities_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_ComputerSystemCapabilities>& instances, const char** properties, string& errorMessage, const string& discriminant);

int Base_Server_OpenDRIM_ComputerSystemCapabilities_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_ComputerSystemCapabilities& instance, const char** properties, string& errorMessage);

int Base_Server_OpenDRIM_ComputerSystemCapabilities_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemCapabilities& newInstance, const OpenDRIM_ComputerSystemCapabilities& oldInstance, const char** properties, string& errorMessage);

int Base_Server_OpenDRIM_ComputerSystemCapabilities_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemCapabilities& instance, string& errorMessage);

int Base_Server_OpenDRIM_ComputerSystemCapabilities_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemCapabilities& instance, string& errorMessage);

int Base_Server_OpenDRIM_ComputerSystemCapabilities_CreateGoalSettings(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemCapabilities& instance, unsigned short& returnValue, const OpenDRIM_ComputerSystemCapabilities_CreateGoalSettings_In& in, OpenDRIM_ComputerSystemCapabilities_CreateGoalSettings_Out& out, string& errorMessage);

int Base_Server_OpenDRIM_ComputerSystemCapabilities_populate(OpenDRIM_ComputerSystemCapabilities& instance, string& errorMessage);

#endif /*OPENDRIM_COMPUTERSYSTEMCAPABILITIESACCESS_H_*/
