/*###############################################################################
# Linux Management Providers (LMP), Base_Server provider package
# Copyright (C) 2007 Ilsoo Byun, ETRI <widepis@etri.re.kr ,widepis@empal.com>
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2008 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
###############################################################################*/

#include "cmpiOpenDRIM_ComputerSystemConformsToProfile.h"

CMPIObjectPath* Base_Server_OpenDRIM_ComputerSystemConformsToProfile_toCMPIObjectPath(const CMPIBroker* broker, const OpenDRIM_ComputerSystemConformsToProfile& instance) {
	_E_;
	Objectpath op(broker, OpenDRIM_ComputerSystemConformsToProfile_classnames[0], OpenDRIM_ComputerSystemConformsToProfile_NAMESPACE);

	if (!instance.ConformantStandard_isNULL)
		op.addKey("ConformantStandard", instance.ConformantStandard);

	if (!instance.ManagedElement_isNULL)
		op.addKey("ManagedElement", instance.ManagedElement);

	_L_;
	return op.getHdl();
}

CMPIInstance* Base_Server_OpenDRIM_ComputerSystemConformsToProfile_toCMPIInstance(const CMPIBroker* broker, const OpenDRIM_ComputerSystemConformsToProfile& instance) {
	_E_;
	Objectpath op(broker, Base_Server_OpenDRIM_ComputerSystemConformsToProfile_toCMPIObjectPath(broker, instance));
	Instance ci(broker, op);

	_L_;
	return ci.getHdl();
}

void Base_Server_OpenDRIM_ComputerSystemConformsToProfile_toCPP(const CMPIBroker* broker, const CMPIObjectPath* ref, OpenDRIM_ComputerSystemConformsToProfile& instance) {
	_E_;
	Objectpath op(broker, (CMPIObjectPath*) ref);

	if (op.getKey("ConformantStandard", instance.ConformantStandard) == OK)
		instance.ConformantStandard_isNULL = false;

	if (op.getKey("ManagedElement", instance.ManagedElement) == OK)
		instance.ManagedElement_isNULL = false;

	_L_;
}

void Base_Server_OpenDRIM_ComputerSystemConformsToProfile_toCPP(const CMPIBroker* broker, const CMPIInstance* ci, OpenDRIM_ComputerSystemConformsToProfile& instance) {
	_E_;
	Instance inst(broker, (CMPIInstance*) ci);

	if (inst.getProperty("ConformantStandard", instance.ConformantStandard) == OK)
		instance.ConformantStandard_isNULL = false;

	if (inst.getProperty("ManagedElement", instance.ManagedElement) == OK)
		instance.ManagedElement_isNULL = false;

	_L_;
}

